// MCLIoExmDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MCLIoExm.h"
#include "MCLIoExmDlg.h"
#include <CString>
#include <math.h>


#import "C:\WINDOWS\system32\MCL_USB_To_IO.dll"



#ifdef _DEBUG
#define new DEBUG_NEW
#endif

using namespace MCL_USB_To_IO;

byte ByteArr[8];
char PortName;




// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CMCLIoExmDlg dialog




CMCLIoExmDlg::CMCLIoExmDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMCLIoExmDlg::IDD, pParent)
	, b0(_T(""))
	, b1(_T(""))
	, b2(_T(""))
	, b3(_T(""))
	, b4(_T(""))
	, b5(_T(""))
	, b6(_T(""))
	, b7(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMCLIoExmDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, b0);
	DDX_Text(pDX, IDC_EDIT2, b1);
	DDX_Text(pDX, IDC_EDIT3, b2);
	DDX_Text(pDX, IDC_EDIT4, b3);
	DDX_Text(pDX, IDC_EDIT5, b4);
	DDX_Text(pDX, IDC_EDIT6, b5);
	DDX_Text(pDX, IDC_EDIT7, b6);
	DDX_Text(pDX, IDC_EDIT8, b7);
}

BEGIN_MESSAGE_MAP(CMCLIoExmDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RADIO1, &CMCLIoExmDlg::OnBnClickedRadio1)
	ON_BN_CLICKED(IDC_RADIO2, &CMCLIoExmDlg::OnBnClickedRadio2)
	ON_EN_CHANGE(IDC_EDIT1, &CMCLIoExmDlg::OnEnChangeEdit1)
	ON_EN_CHANGE(IDC_EDIT2, &CMCLIoExmDlg::OnEnChangeEdit2)
	ON_EN_CHANGE(IDC_EDIT3, &CMCLIoExmDlg::OnEnChangeEdit3)
	ON_EN_CHANGE(IDC_EDIT4, &CMCLIoExmDlg::OnEnChangeEdit4)
	ON_EN_CHANGE(IDC_EDIT5, &CMCLIoExmDlg::OnEnChangeEdit5)
	ON_EN_CHANGE(IDC_EDIT6, &CMCLIoExmDlg::OnEnChangeEdit6)
	ON_EN_CHANGE(IDC_EDIT7, &CMCLIoExmDlg::OnEnChangeEdit7)
	ON_EN_CHANGE(IDC_EDIT8, &CMCLIoExmDlg::OnEnChangeEdit8)
	ON_BN_CLICKED(IDC_BUTTON1, &CMCLIoExmDlg::OnBnClickedButton1)
END_MESSAGE_MAP()


// CMCLIoExmDlg message handlers

BOOL CMCLIoExmDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMCLIoExmDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMCLIoExmDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMCLIoExmDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CMCLIoExmDlg::OnBnClickedRadio1()
{
	HRESULT hresult;
	CLSID clsid;

	CoInitialize(NULL);	//initialize COM library
	hresult=CLSIDFromProgID(OLESTR("MCL_USB_To_IO.USB_IO"), &clsid); 
	
	_USB_IO *MyIO;
	hresult=CoCreateInstance(clsid,NULL,CLSCTX_INPROC_SERVER,__uuidof(_USB_IO),(LPVOID *) &MyIO);



	
	
	int status = MyIO->Connect("");
	status = MyIO->Set_ByteA_As_Output();
	MyIO->Disconnect();

	PortName = 'A';



	// TODO: Add your control notification handler code here
}

void CMCLIoExmDlg::OnBnClickedRadio2()
{
	HRESULT hresult;
	CLSID clsid;

	CoInitialize(NULL);	//initialize COM library
	hresult=CLSIDFromProgID(OLESTR("MCL_USB_To_IO.USB_IO"), &clsid); 
	
	_USB_IO *MyIO;
	hresult=CoCreateInstance(clsid,NULL,CLSCTX_INPROC_SERVER,__uuidof(_USB_IO),(LPVOID *) &MyIO);

	
	int status = MyIO->Connect("");
	status = MyIO->Set_ByteB_As_Output();
	MyIO->Disconnect();

	PortName = 'B';
	// TODO: Add your control notification handler code here
}

void CMCLIoExmDlg::OnEnChangeEdit1()
{
	CString val;

	GetDlgItemText(IDC_EDIT1,val);
	
	int nSize = val.GetLength();
	char *tmp = new char[nSize+1];
	memset(tmp,0,nSize+1);
	wcstombs(tmp, val, nSize+1);

	int b = atoi(tmp);
	ByteArr[0] = b;



	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
}

void CMCLIoExmDlg::OnEnChangeEdit2()
{



	CString val;

	GetDlgItemText(IDC_EDIT2,val);
	
	int nSize = val.GetLength();
	char *tmp = new char[nSize+1];
	memset(tmp,0,nSize+1);
	wcstombs(tmp, val, nSize+1);

	int b = atoi(tmp);
	ByteArr[1] = b;

	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
}

void CMCLIoExmDlg::OnEnChangeEdit3()
{
	CString val;

	GetDlgItemText(IDC_EDIT3,val);
	
	int nSize = val.GetLength();
	char *tmp = new char[nSize+1];
	memset(tmp,0,nSize+1);
	wcstombs(tmp, val, nSize+1);

	int b = atoi(tmp);
	ByteArr[2] = b;



	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
}

void CMCLIoExmDlg::OnEnChangeEdit4()
{
	CString val;

	GetDlgItemText(IDC_EDIT4,val);
	
	int nSize = val.GetLength();
	char *tmp = new char[nSize+1];
	memset(tmp,0,nSize+1);
	wcstombs(tmp, val, nSize+1);

	int b = atoi(tmp);
	ByteArr[3] = b;
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
}

void CMCLIoExmDlg::OnEnChangeEdit5()
{
	CString val;

	GetDlgItemText(IDC_EDIT5,val);
	
	int nSize = val.GetLength();
	char *tmp = new char[nSize+1];
	memset(tmp,0,nSize+1);
	wcstombs(tmp, val, nSize+1);

	int b = atoi(tmp);
	ByteArr[4] = b;
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
}

void CMCLIoExmDlg::OnEnChangeEdit6()
{
	CString val;

	GetDlgItemText(IDC_EDIT6,val);
	
	int nSize = val.GetLength();
	char *tmp = new char[nSize+1];
	memset(tmp,0,nSize+1);
	wcstombs(tmp, val, nSize+1);

	int b = atoi(tmp);
	ByteArr[5] = b;
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
}

void CMCLIoExmDlg::OnEnChangeEdit7()
{
	CString val;

	GetDlgItemText(IDC_EDIT7,val);
	
	int nSize = val.GetLength();
	char *tmp = new char[nSize+1];
	memset(tmp,0,nSize+1);
	wcstombs(tmp, val, nSize+1);

	int b = atoi(tmp);
	ByteArr[6] = b;
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
}

void CMCLIoExmDlg::OnEnChangeEdit8()
{
	CString val;

	GetDlgItemText(IDC_EDIT8,val);
	
	int nSize = val.GetLength();
	char *tmp = new char[nSize+1];
	memset(tmp,0,nSize+1);
	wcstombs(tmp, val, nSize+1);

	int b = atoi(tmp);
	ByteArr[7] = b;
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
}


unsigned char CalcByte() 
{
	unsigned char result=0;
	for (int i=0; i<8; i++)
		result+= ByteArr[i] * pow(2.0,(double)i);

	return result;



}

void CMCLIoExmDlg::OnBnClickedButton1()
{
	unsigned char b ;

	b= CalcByte();

	HRESULT hresult;
	CLSID clsid;

	CoInitialize(NULL);	//initialize COM library
	hresult=CLSIDFromProgID(OLESTR("MCL_USB_To_IO.USB_IO"), &clsid); 
	
	_USB_IO *MyIO;
	hresult=CoCreateInstance(clsid,NULL,CLSCTX_INPROC_SERVER,__uuidof(_USB_IO),(LPVOID *) &MyIO);

	
	int status = MyIO->Connect("");


	switch(PortName) {
		case 'A':
			status = MyIO->Set_ByteA(&b);
			break;

		case 'B':
			status = MyIO->Set_ByteB(&b);
			break;





	}


	

	// TODO: Add your control notification handler code here
}



